---
title: Response.clone()
slug: Web/API/Response/clone
tags:
  - API
  - Experimental
  - Fetch
  - Method
  - Reference
  - Response
  - clone
---
<div>{{APIRef("Fetch")}}</div>

<p>The <strong><code>clone()</code></strong> method of the {{domxref("Response")}} interface creates a clone of a response object, identical in every way, but stored in a different variable.</p>

<p><code>clone()</code> throws a {{jsxref("TypeError")}} if the response {{domxref("Body")}} has already been used. In fact, the main reason <code>clone()</code> exists is to allow multiple uses of {{domxref("Body")}} objects (when they are one-use only.)</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <var>response2</var> = <var>response1</var>.clone();</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Value">Value</h3>

<p>A {{domxref("Response")}} object.</p>

<h2 id="Example">Example</h2>

<p>In our <a href="https://github.com/mdn/fetch-examples/tree/gh-pages/fetch-response-clone">Fetch Response clone example</a> (see <a href="https://mdn.github.io/fetch-examples/fetch-response-clone/">Fetch Response clone live</a>) we create a new {{domxref("Request")}} object using the {{domxref("Request.Request","Request()")}} constructor, passing it a JPG path. We then fetch this request using {{domxref("GlobalFetch.fetch","fetch()")}}. When the fetch resolves successfully, we clone it, extract a blob from both responses using two {{domxref("Body.blob")}} calls, create object URLs out of the blobs using {{domxref("URL.createObjectURL")}}, and display them in two separate {{htmlelement("img")}} elements.</p>

<pre class="brush: js">var image1 = document.querySelector('.img1');
var image2 = document.querySelector('.img2');

var myRequest = new Request('flowers.jpg');

fetch(myRequest).then(function(response) {
  var response2 = response.clone();

  response.blob().then(function(myBlob) {
    var objectURL = URL.createObjectURL(myBlob);
    image1.src = objectURL;
  });

  response2.blob().then(function(myBlob) {
    var objectURL = URL.createObjectURL(myBlob);
    image2.src = objectURL;
  });
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Fetch','#dom-response-clone','clone()')}}</td>
   <td>{{Spec2('Fetch')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Response.clone")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API">ServiceWorker API</a></li>
 <li><a href="/en-US/docs/Web/HTTP/Access_control_CORS">HTTP access control (CORS)</a></li>
 <li><a href="/en-US/docs/Web/HTTP">HTTP</a></li>
</ul>
